"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.9-4506
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from intersight.model.capability_port_range import CapabilityPortRange
    from intersight.model.capability_switch_network_limits import CapabilitySwitchNetworkLimits
    from intersight.model.capability_switch_storage_limits import CapabilitySwitchStorageLimits
    from intersight.model.capability_switch_system_limits import CapabilitySwitchSystemLimits
    from intersight.model.capability_switching_mode_capability import CapabilitySwitchingModeCapability
    globals()['CapabilityPortRange'] = CapabilityPortRange
    globals()['CapabilitySwitchNetworkLimits'] = CapabilitySwitchNetworkLimits
    globals()['CapabilitySwitchStorageLimits'] = CapabilitySwitchStorageLimits
    globals()['CapabilitySwitchSystemLimits'] = CapabilitySwitchSystemLimits
    globals()['CapabilitySwitchingModeCapability'] = CapabilitySwitchingModeCapability


class CapabilitySwitchCapabilityAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'CAPABILITY.SWITCHCAPABILITY': "capability.SwitchCapability",
        },
        ('object_type',): {
            'CAPABILITY.SWITCHCAPABILITY': "capability.SwitchCapability",
        },
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'default_fcoe_vlan': (int,),  # noqa: E501
            'dynamic_vifs_supported': (bool,),  # noqa: E501
            'fan_modules_supported': (bool,),  # noqa: E501
            'fc_end_host_mode_reserved_vsans': ([CapabilityPortRange], none_type,),  # noqa: E501
            'fc_uplink_ports_auto_negotiation_supported': (bool,),  # noqa: E501
            'locator_beacon_supported': (bool,),  # noqa: E501
            'max_ports': (int,),  # noqa: E501
            'max_slots': (int,),  # noqa: E501
            'network_limits': (CapabilitySwitchNetworkLimits,),  # noqa: E501
            'ports_supporting100g_speed': ([CapabilityPortRange], none_type,),  # noqa: E501
            'ports_supporting10g_speed': ([CapabilityPortRange], none_type,),  # noqa: E501
            'ports_supporting1g_speed': ([CapabilityPortRange], none_type,),  # noqa: E501
            'ports_supporting25g_speed': ([CapabilityPortRange], none_type,),  # noqa: E501
            'ports_supporting40g_speed': ([CapabilityPortRange], none_type,),  # noqa: E501
            'ports_supporting_breakout': ([CapabilityPortRange], none_type,),  # noqa: E501
            'ports_supporting_fcoe': ([CapabilityPortRange], none_type,),  # noqa: E501
            'ports_supporting_server_role': ([CapabilityPortRange], none_type,),  # noqa: E501
            'reserved_vsans': ([CapabilityPortRange], none_type,),  # noqa: E501
            'sereno_netflow_supported': (bool,),  # noqa: E501
            'storage_limits': (CapabilitySwitchStorageLimits,),  # noqa: E501
            'switching_mode_capabilities': ([CapabilitySwitchingModeCapability], none_type,),  # noqa: E501
            'system_limits': (CapabilitySwitchSystemLimits,),  # noqa: E501
            'unified_ports': ([CapabilityPortRange], none_type,),  # noqa: E501
            'unified_rule': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'default_fcoe_vlan': 'DefaultFcoeVlan',  # noqa: E501
        'dynamic_vifs_supported': 'DynamicVifsSupported',  # noqa: E501
        'fan_modules_supported': 'FanModulesSupported',  # noqa: E501
        'fc_end_host_mode_reserved_vsans': 'FcEndHostModeReservedVsans',  # noqa: E501
        'fc_uplink_ports_auto_negotiation_supported': 'FcUplinkPortsAutoNegotiationSupported',  # noqa: E501
        'locator_beacon_supported': 'LocatorBeaconSupported',  # noqa: E501
        'max_ports': 'MaxPorts',  # noqa: E501
        'max_slots': 'MaxSlots',  # noqa: E501
        'network_limits': 'NetworkLimits',  # noqa: E501
        'ports_supporting100g_speed': 'PortsSupporting100gSpeed',  # noqa: E501
        'ports_supporting10g_speed': 'PortsSupporting10gSpeed',  # noqa: E501
        'ports_supporting1g_speed': 'PortsSupporting1gSpeed',  # noqa: E501
        'ports_supporting25g_speed': 'PortsSupporting25gSpeed',  # noqa: E501
        'ports_supporting40g_speed': 'PortsSupporting40gSpeed',  # noqa: E501
        'ports_supporting_breakout': 'PortsSupportingBreakout',  # noqa: E501
        'ports_supporting_fcoe': 'PortsSupportingFcoe',  # noqa: E501
        'ports_supporting_server_role': 'PortsSupportingServerRole',  # noqa: E501
        'reserved_vsans': 'ReservedVsans',  # noqa: E501
        'sereno_netflow_supported': 'SerenoNetflowSupported',  # noqa: E501
        'storage_limits': 'StorageLimits',  # noqa: E501
        'switching_mode_capabilities': 'SwitchingModeCapabilities',  # noqa: E501
        'system_limits': 'SystemLimits',  # noqa: E501
        'unified_ports': 'UnifiedPorts',  # noqa: E501
        'unified_rule': 'UnifiedRule',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """CapabilitySwitchCapabilityAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "capability.SwitchCapability", must be one of ["capability.SwitchCapability", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "capability.SwitchCapability", must be one of ["capability.SwitchCapability", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            default_fcoe_vlan (int): Default Fcoe VLAN associated with this switch.. [optional]  # noqa: E501
            dynamic_vifs_supported (bool): Dynamic VIFs support on this switch.. [optional]  # noqa: E501
            fan_modules_supported (bool): Fan Modules support on this switch.. [optional]  # noqa: E501
            fc_end_host_mode_reserved_vsans ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            fc_uplink_ports_auto_negotiation_supported (bool): Fc Uplink ports auto negotiation speed support on this switch.. [optional]  # noqa: E501
            locator_beacon_supported (bool): Locator Beacon LED support on this switch.. [optional]  # noqa: E501
            max_ports (int): Maximum allowed physical ports on this switch.. [optional]  # noqa: E501
            max_slots (int): Maximum allowed physical slots on this switch.. [optional]  # noqa: E501
            network_limits (CapabilitySwitchNetworkLimits): [optional]  # noqa: E501
            ports_supporting100g_speed ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            ports_supporting10g_speed ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            ports_supporting1g_speed ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            ports_supporting25g_speed ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            ports_supporting40g_speed ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            ports_supporting_breakout ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            ports_supporting_fcoe ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            ports_supporting_server_role ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            reserved_vsans ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            sereno_netflow_supported (bool): Sereno Adaptor with Netflow support on this switch.. [optional]  # noqa: E501
            storage_limits (CapabilitySwitchStorageLimits): [optional]  # noqa: E501
            switching_mode_capabilities ([CapabilitySwitchingModeCapability], none_type): [optional]  # noqa: E501
            system_limits (CapabilitySwitchSystemLimits): [optional]  # noqa: E501
            unified_ports ([CapabilityPortRange], none_type): [optional]  # noqa: E501
            unified_rule (str): The Slider rule for Unified ports on this switch.. [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "capability.SwitchCapability")
        object_type = kwargs.get('object_type', "capability.SwitchCapability")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
