"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.9-4506
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from intersight.model.asset_device_registration_relationship import AssetDeviceRegistrationRelationship
    from intersight.model.cloud_aws_key_pair import CloudAwsKeyPair
    from intersight.model.cloud_aws_network_interface import CloudAwsNetworkInterface
    from intersight.model.cloud_aws_security_group import CloudAwsSecurityGroup
    from intersight.model.cloud_aws_subnet import CloudAwsSubnet
    from intersight.model.cloud_aws_virtual_machine import CloudAwsVirtualMachine
    from intersight.model.cloud_aws_volume import CloudAwsVolume
    from intersight.model.cloud_aws_vpc import CloudAwsVpc
    from intersight.model.cloud_base_entity import CloudBaseEntity
    from intersight.model.cloud_base_network import CloudBaseNetwork
    from intersight.model.cloud_base_network_interface import CloudBaseNetworkInterface
    from intersight.model.cloud_base_placement import CloudBasePlacement
    from intersight.model.cloud_base_virtual_machine import CloudBaseVirtualMachine
    from intersight.model.cloud_base_volume import CloudBaseVolume
    from intersight.model.display_names import DisplayNames
    from intersight.model.hyperflex_hxap_datacenter import HyperflexHxapDatacenter
    from intersight.model.hyperflex_hxap_dv_uplink import HyperflexHxapDvUplink
    from intersight.model.hyperflex_hxap_dvswitch import HyperflexHxapDvswitch
    from intersight.model.hyperflex_hxap_host import HyperflexHxapHost
    from intersight.model.hyperflex_hxap_host_vswitch import HyperflexHxapHostVswitch
    from intersight.model.hyperflex_hxap_network import HyperflexHxapNetwork
    from intersight.model.hyperflex_hxap_virtual_disk import HyperflexHxapVirtualDisk
    from intersight.model.hyperflex_hxap_virtual_machine import HyperflexHxapVirtualMachine
    from intersight.model.hyperflex_hxap_virtual_machine_network_interface import HyperflexHxapVirtualMachineNetworkInterface
    from intersight.model.mo_base_mo import MoBaseMo
    from intersight.model.mo_base_mo_relationship import MoBaseMoRelationship
    from intersight.model.mo_tag import MoTag
    from intersight.model.mo_version_context import MoVersionContext
    from intersight.model.virtualization_base_datacenter import VirtualizationBaseDatacenter
    from intersight.model.virtualization_base_datastore import VirtualizationBaseDatastore
    from intersight.model.virtualization_base_datastore_cluster import VirtualizationBaseDatastoreCluster
    from intersight.model.virtualization_base_distributed_network import VirtualizationBaseDistributedNetwork
    from intersight.model.virtualization_base_distributed_switch import VirtualizationBaseDistributedSwitch
    from intersight.model.virtualization_base_dvswitch import VirtualizationBaseDvswitch
    from intersight.model.virtualization_base_folder import VirtualizationBaseFolder
    from intersight.model.virtualization_base_host import VirtualizationBaseHost
    from intersight.model.virtualization_base_kernel_network import VirtualizationBaseKernelNetwork
    from intersight.model.virtualization_base_network import VirtualizationBaseNetwork
    from intersight.model.virtualization_base_physical_network_interface import VirtualizationBasePhysicalNetworkInterface
    from intersight.model.virtualization_base_placement import VirtualizationBasePlacement
    from intersight.model.virtualization_base_source_device_all_of import VirtualizationBaseSourceDeviceAllOf
    from intersight.model.virtualization_base_switch import VirtualizationBaseSwitch
    from intersight.model.virtualization_base_virtual_disk import VirtualizationBaseVirtualDisk
    from intersight.model.virtualization_base_virtual_machine import VirtualizationBaseVirtualMachine
    from intersight.model.virtualization_base_virtual_machine_snapshot import VirtualizationBaseVirtualMachineSnapshot
    from intersight.model.virtualization_base_virtual_network import VirtualizationBaseVirtualNetwork
    from intersight.model.virtualization_base_virtual_network_interface import VirtualizationBaseVirtualNetworkInterface
    from intersight.model.virtualization_base_virtual_network_interface_card import VirtualizationBaseVirtualNetworkInterfaceCard
    from intersight.model.virtualization_base_virtual_switch import VirtualizationBaseVirtualSwitch
    from intersight.model.virtualization_base_vswitch import VirtualizationBaseVswitch
    from intersight.model.virtualization_vmware_datacenter import VirtualizationVmwareDatacenter
    from intersight.model.virtualization_vmware_datastore import VirtualizationVmwareDatastore
    from intersight.model.virtualization_vmware_datastore_cluster import VirtualizationVmwareDatastoreCluster
    from intersight.model.virtualization_vmware_distributed_network import VirtualizationVmwareDistributedNetwork
    from intersight.model.virtualization_vmware_distributed_switch import VirtualizationVmwareDistributedSwitch
    from intersight.model.virtualization_vmware_folder import VirtualizationVmwareFolder
    from intersight.model.virtualization_vmware_host import VirtualizationVmwareHost
    from intersight.model.virtualization_vmware_kernel_network import VirtualizationVmwareKernelNetwork
    from intersight.model.virtualization_vmware_network import VirtualizationVmwareNetwork
    from intersight.model.virtualization_vmware_physical_network_interface import VirtualizationVmwarePhysicalNetworkInterface
    from intersight.model.virtualization_vmware_uplink_port import VirtualizationVmwareUplinkPort
    from intersight.model.virtualization_vmware_virtual_disk import VirtualizationVmwareVirtualDisk
    from intersight.model.virtualization_vmware_virtual_machine import VirtualizationVmwareVirtualMachine
    from intersight.model.virtualization_vmware_virtual_machine_snapshot import VirtualizationVmwareVirtualMachineSnapshot
    from intersight.model.virtualization_vmware_virtual_network_interface import VirtualizationVmwareVirtualNetworkInterface
    from intersight.model.virtualization_vmware_virtual_switch import VirtualizationVmwareVirtualSwitch
    globals()['AssetDeviceRegistrationRelationship'] = AssetDeviceRegistrationRelationship
    globals()['CloudAwsKeyPair'] = CloudAwsKeyPair
    globals()['CloudAwsNetworkInterface'] = CloudAwsNetworkInterface
    globals()['CloudAwsSecurityGroup'] = CloudAwsSecurityGroup
    globals()['CloudAwsSubnet'] = CloudAwsSubnet
    globals()['CloudAwsVirtualMachine'] = CloudAwsVirtualMachine
    globals()['CloudAwsVolume'] = CloudAwsVolume
    globals()['CloudAwsVpc'] = CloudAwsVpc
    globals()['CloudBaseEntity'] = CloudBaseEntity
    globals()['CloudBaseNetwork'] = CloudBaseNetwork
    globals()['CloudBaseNetworkInterface'] = CloudBaseNetworkInterface
    globals()['CloudBasePlacement'] = CloudBasePlacement
    globals()['CloudBaseVirtualMachine'] = CloudBaseVirtualMachine
    globals()['CloudBaseVolume'] = CloudBaseVolume
    globals()['DisplayNames'] = DisplayNames
    globals()['HyperflexHxapDatacenter'] = HyperflexHxapDatacenter
    globals()['HyperflexHxapDvUplink'] = HyperflexHxapDvUplink
    globals()['HyperflexHxapDvswitch'] = HyperflexHxapDvswitch
    globals()['HyperflexHxapHost'] = HyperflexHxapHost
    globals()['HyperflexHxapHostVswitch'] = HyperflexHxapHostVswitch
    globals()['HyperflexHxapNetwork'] = HyperflexHxapNetwork
    globals()['HyperflexHxapVirtualDisk'] = HyperflexHxapVirtualDisk
    globals()['HyperflexHxapVirtualMachine'] = HyperflexHxapVirtualMachine
    globals()['HyperflexHxapVirtualMachineNetworkInterface'] = HyperflexHxapVirtualMachineNetworkInterface
    globals()['MoBaseMo'] = MoBaseMo
    globals()['MoBaseMoRelationship'] = MoBaseMoRelationship
    globals()['MoTag'] = MoTag
    globals()['MoVersionContext'] = MoVersionContext
    globals()['VirtualizationBaseDatacenter'] = VirtualizationBaseDatacenter
    globals()['VirtualizationBaseDatastore'] = VirtualizationBaseDatastore
    globals()['VirtualizationBaseDatastoreCluster'] = VirtualizationBaseDatastoreCluster
    globals()['VirtualizationBaseDistributedNetwork'] = VirtualizationBaseDistributedNetwork
    globals()['VirtualizationBaseDistributedSwitch'] = VirtualizationBaseDistributedSwitch
    globals()['VirtualizationBaseDvswitch'] = VirtualizationBaseDvswitch
    globals()['VirtualizationBaseFolder'] = VirtualizationBaseFolder
    globals()['VirtualizationBaseHost'] = VirtualizationBaseHost
    globals()['VirtualizationBaseKernelNetwork'] = VirtualizationBaseKernelNetwork
    globals()['VirtualizationBaseNetwork'] = VirtualizationBaseNetwork
    globals()['VirtualizationBasePhysicalNetworkInterface'] = VirtualizationBasePhysicalNetworkInterface
    globals()['VirtualizationBasePlacement'] = VirtualizationBasePlacement
    globals()['VirtualizationBaseSourceDeviceAllOf'] = VirtualizationBaseSourceDeviceAllOf
    globals()['VirtualizationBaseSwitch'] = VirtualizationBaseSwitch
    globals()['VirtualizationBaseVirtualDisk'] = VirtualizationBaseVirtualDisk
    globals()['VirtualizationBaseVirtualMachine'] = VirtualizationBaseVirtualMachine
    globals()['VirtualizationBaseVirtualMachineSnapshot'] = VirtualizationBaseVirtualMachineSnapshot
    globals()['VirtualizationBaseVirtualNetwork'] = VirtualizationBaseVirtualNetwork
    globals()['VirtualizationBaseVirtualNetworkInterface'] = VirtualizationBaseVirtualNetworkInterface
    globals()['VirtualizationBaseVirtualNetworkInterfaceCard'] = VirtualizationBaseVirtualNetworkInterfaceCard
    globals()['VirtualizationBaseVirtualSwitch'] = VirtualizationBaseVirtualSwitch
    globals()['VirtualizationBaseVswitch'] = VirtualizationBaseVswitch
    globals()['VirtualizationVmwareDatacenter'] = VirtualizationVmwareDatacenter
    globals()['VirtualizationVmwareDatastore'] = VirtualizationVmwareDatastore
    globals()['VirtualizationVmwareDatastoreCluster'] = VirtualizationVmwareDatastoreCluster
    globals()['VirtualizationVmwareDistributedNetwork'] = VirtualizationVmwareDistributedNetwork
    globals()['VirtualizationVmwareDistributedSwitch'] = VirtualizationVmwareDistributedSwitch
    globals()['VirtualizationVmwareFolder'] = VirtualizationVmwareFolder
    globals()['VirtualizationVmwareHost'] = VirtualizationVmwareHost
    globals()['VirtualizationVmwareKernelNetwork'] = VirtualizationVmwareKernelNetwork
    globals()['VirtualizationVmwareNetwork'] = VirtualizationVmwareNetwork
    globals()['VirtualizationVmwarePhysicalNetworkInterface'] = VirtualizationVmwarePhysicalNetworkInterface
    globals()['VirtualizationVmwareUplinkPort'] = VirtualizationVmwareUplinkPort
    globals()['VirtualizationVmwareVirtualDisk'] = VirtualizationVmwareVirtualDisk
    globals()['VirtualizationVmwareVirtualMachine'] = VirtualizationVmwareVirtualMachine
    globals()['VirtualizationVmwareVirtualMachineSnapshot'] = VirtualizationVmwareVirtualMachineSnapshot
    globals()['VirtualizationVmwareVirtualNetworkInterface'] = VirtualizationVmwareVirtualNetworkInterface
    globals()['VirtualizationVmwareVirtualSwitch'] = VirtualizationVmwareVirtualSwitch


class VirtualizationBaseSourceDevice(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'CLOUD.AWSKEYPAIR': "cloud.AwsKeyPair",
            'CLOUD.AWSNETWORKINTERFACE': "cloud.AwsNetworkInterface",
            'CLOUD.AWSSECURITYGROUP': "cloud.AwsSecurityGroup",
            'CLOUD.AWSSUBNET': "cloud.AwsSubnet",
            'CLOUD.AWSVIRTUALMACHINE': "cloud.AwsVirtualMachine",
            'CLOUD.AWSVOLUME': "cloud.AwsVolume",
            'CLOUD.AWSVPC': "cloud.AwsVpc",
            'HYPERFLEX.HXAPDATACENTER': "hyperflex.HxapDatacenter",
            'HYPERFLEX.HXAPDVUPLINK': "hyperflex.HxapDvUplink",
            'HYPERFLEX.HXAPDVSWITCH': "hyperflex.HxapDvswitch",
            'HYPERFLEX.HXAPHOST': "hyperflex.HxapHost",
            'HYPERFLEX.HXAPHOSTVSWITCH': "hyperflex.HxapHostVswitch",
            'HYPERFLEX.HXAPNETWORK': "hyperflex.HxapNetwork",
            'HYPERFLEX.HXAPVIRTUALDISK': "hyperflex.HxapVirtualDisk",
            'HYPERFLEX.HXAPVIRTUALMACHINE': "hyperflex.HxapVirtualMachine",
            'HYPERFLEX.HXAPVIRTUALMACHINENETWORKINTERFACE': "hyperflex.HxapVirtualMachineNetworkInterface",
            'VIRTUALIZATION.VMWAREDATACENTER': "virtualization.VmwareDatacenter",
            'VIRTUALIZATION.VMWAREDATASTORE': "virtualization.VmwareDatastore",
            'VIRTUALIZATION.VMWAREDATASTORECLUSTER': "virtualization.VmwareDatastoreCluster",
            'VIRTUALIZATION.VMWAREDISTRIBUTEDNETWORK': "virtualization.VmwareDistributedNetwork",
            'VIRTUALIZATION.VMWAREDISTRIBUTEDSWITCH': "virtualization.VmwareDistributedSwitch",
            'VIRTUALIZATION.VMWAREFOLDER': "virtualization.VmwareFolder",
            'VIRTUALIZATION.VMWAREHOST': "virtualization.VmwareHost",
            'VIRTUALIZATION.VMWAREKERNELNETWORK': "virtualization.VmwareKernelNetwork",
            'VIRTUALIZATION.VMWARENETWORK': "virtualization.VmwareNetwork",
            'VIRTUALIZATION.VMWAREPHYSICALNETWORKINTERFACE': "virtualization.VmwarePhysicalNetworkInterface",
            'VIRTUALIZATION.VMWAREUPLINKPORT': "virtualization.VmwareUplinkPort",
            'VIRTUALIZATION.VMWAREVIRTUALDISK': "virtualization.VmwareVirtualDisk",
            'VIRTUALIZATION.VMWAREVIRTUALMACHINE': "virtualization.VmwareVirtualMachine",
            'VIRTUALIZATION.VMWAREVIRTUALMACHINESNAPSHOT': "virtualization.VmwareVirtualMachineSnapshot",
            'VIRTUALIZATION.VMWAREVIRTUALNETWORKINTERFACE': "virtualization.VmwareVirtualNetworkInterface",
            'VIRTUALIZATION.VMWAREVIRTUALSWITCH': "virtualization.VmwareVirtualSwitch",
        },
        ('object_type',): {
            'CLOUD.AWSKEYPAIR': "cloud.AwsKeyPair",
            'CLOUD.AWSNETWORKINTERFACE': "cloud.AwsNetworkInterface",
            'CLOUD.AWSSECURITYGROUP': "cloud.AwsSecurityGroup",
            'CLOUD.AWSSUBNET': "cloud.AwsSubnet",
            'CLOUD.AWSVIRTUALMACHINE': "cloud.AwsVirtualMachine",
            'CLOUD.AWSVOLUME': "cloud.AwsVolume",
            'CLOUD.AWSVPC': "cloud.AwsVpc",
            'HYPERFLEX.HXAPDATACENTER': "hyperflex.HxapDatacenter",
            'HYPERFLEX.HXAPDVUPLINK': "hyperflex.HxapDvUplink",
            'HYPERFLEX.HXAPDVSWITCH': "hyperflex.HxapDvswitch",
            'HYPERFLEX.HXAPHOST': "hyperflex.HxapHost",
            'HYPERFLEX.HXAPHOSTVSWITCH': "hyperflex.HxapHostVswitch",
            'HYPERFLEX.HXAPNETWORK': "hyperflex.HxapNetwork",
            'HYPERFLEX.HXAPVIRTUALDISK': "hyperflex.HxapVirtualDisk",
            'HYPERFLEX.HXAPVIRTUALMACHINE': "hyperflex.HxapVirtualMachine",
            'HYPERFLEX.HXAPVIRTUALMACHINENETWORKINTERFACE': "hyperflex.HxapVirtualMachineNetworkInterface",
            'VIRTUALIZATION.VMWAREDATACENTER': "virtualization.VmwareDatacenter",
            'VIRTUALIZATION.VMWAREDATASTORE': "virtualization.VmwareDatastore",
            'VIRTUALIZATION.VMWAREDATASTORECLUSTER': "virtualization.VmwareDatastoreCluster",
            'VIRTUALIZATION.VMWAREDISTRIBUTEDNETWORK': "virtualization.VmwareDistributedNetwork",
            'VIRTUALIZATION.VMWAREDISTRIBUTEDSWITCH': "virtualization.VmwareDistributedSwitch",
            'VIRTUALIZATION.VMWAREFOLDER': "virtualization.VmwareFolder",
            'VIRTUALIZATION.VMWAREHOST': "virtualization.VmwareHost",
            'VIRTUALIZATION.VMWAREKERNELNETWORK': "virtualization.VmwareKernelNetwork",
            'VIRTUALIZATION.VMWARENETWORK': "virtualization.VmwareNetwork",
            'VIRTUALIZATION.VMWAREPHYSICALNETWORKINTERFACE': "virtualization.VmwarePhysicalNetworkInterface",
            'VIRTUALIZATION.VMWAREUPLINKPORT': "virtualization.VmwareUplinkPort",
            'VIRTUALIZATION.VMWAREVIRTUALDISK': "virtualization.VmwareVirtualDisk",
            'VIRTUALIZATION.VMWAREVIRTUALMACHINE': "virtualization.VmwareVirtualMachine",
            'VIRTUALIZATION.VMWAREVIRTUALMACHINESNAPSHOT': "virtualization.VmwareVirtualMachineSnapshot",
            'VIRTUALIZATION.VMWAREVIRTUALNETWORKINTERFACE': "virtualization.VmwareVirtualNetworkInterface",
            'VIRTUALIZATION.VMWAREVIRTUALSWITCH': "virtualization.VmwareVirtualSwitch",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'registered_device': (AssetDeviceRegistrationRelationship,),  # noqa: E501
            'account_moid': (str,),  # noqa: E501
            'create_time': (datetime,),  # noqa: E501
            'domain_group_moid': (str,),  # noqa: E501
            'mod_time': (datetime,),  # noqa: E501
            'moid': (str,),  # noqa: E501
            'owners': ([str], none_type,),  # noqa: E501
            'shared_scope': (str,),  # noqa: E501
            'tags': ([MoTag], none_type,),  # noqa: E501
            'version_context': (MoVersionContext,),  # noqa: E501
            'ancestors': ([MoBaseMoRelationship], none_type,),  # noqa: E501
            'parent': (MoBaseMoRelationship,),  # noqa: E501
            'permission_resources': ([MoBaseMoRelationship], none_type,),  # noqa: E501
            'display_names': (DisplayNames,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        lazy_import()
        val = {
            'cloud.AwsKeyPair': CloudAwsKeyPair,
            'cloud.AwsNetworkInterface': CloudAwsNetworkInterface,
            'cloud.AwsSecurityGroup': CloudAwsSecurityGroup,
            'cloud.AwsSubnet': CloudAwsSubnet,
            'cloud.AwsVirtualMachine': CloudAwsVirtualMachine,
            'cloud.AwsVolume': CloudAwsVolume,
            'cloud.AwsVpc': CloudAwsVpc,
            'cloud.BaseEntity': CloudBaseEntity,
            'cloud.BaseNetwork': CloudBaseNetwork,
            'cloud.BaseNetworkInterface': CloudBaseNetworkInterface,
            'cloud.BasePlacement': CloudBasePlacement,
            'cloud.BaseVirtualMachine': CloudBaseVirtualMachine,
            'cloud.BaseVolume': CloudBaseVolume,
            'hyperflex.HxapDatacenter': HyperflexHxapDatacenter,
            'hyperflex.HxapDvUplink': HyperflexHxapDvUplink,
            'hyperflex.HxapDvswitch': HyperflexHxapDvswitch,
            'hyperflex.HxapHost': HyperflexHxapHost,
            'hyperflex.HxapHostVswitch': HyperflexHxapHostVswitch,
            'hyperflex.HxapNetwork': HyperflexHxapNetwork,
            'hyperflex.HxapVirtualDisk': HyperflexHxapVirtualDisk,
            'hyperflex.HxapVirtualMachine': HyperflexHxapVirtualMachine,
            'hyperflex.HxapVirtualMachineNetworkInterface': HyperflexHxapVirtualMachineNetworkInterface,
            'virtualization.BaseDatacenter': VirtualizationBaseDatacenter,
            'virtualization.BaseDatastore': VirtualizationBaseDatastore,
            'virtualization.BaseDatastoreCluster': VirtualizationBaseDatastoreCluster,
            'virtualization.BaseDistributedNetwork': VirtualizationBaseDistributedNetwork,
            'virtualization.BaseDistributedSwitch': VirtualizationBaseDistributedSwitch,
            'virtualization.BaseDvswitch': VirtualizationBaseDvswitch,
            'virtualization.BaseFolder': VirtualizationBaseFolder,
            'virtualization.BaseHost': VirtualizationBaseHost,
            'virtualization.BaseKernelNetwork': VirtualizationBaseKernelNetwork,
            'virtualization.BaseNetwork': VirtualizationBaseNetwork,
            'virtualization.BasePhysicalNetworkInterface': VirtualizationBasePhysicalNetworkInterface,
            'virtualization.BasePlacement': VirtualizationBasePlacement,
            'virtualization.BaseSwitch': VirtualizationBaseSwitch,
            'virtualization.BaseVirtualDisk': VirtualizationBaseVirtualDisk,
            'virtualization.BaseVirtualMachine': VirtualizationBaseVirtualMachine,
            'virtualization.BaseVirtualMachineSnapshot': VirtualizationBaseVirtualMachineSnapshot,
            'virtualization.BaseVirtualNetwork': VirtualizationBaseVirtualNetwork,
            'virtualization.BaseVirtualNetworkInterface': VirtualizationBaseVirtualNetworkInterface,
            'virtualization.BaseVirtualNetworkInterfaceCard': VirtualizationBaseVirtualNetworkInterfaceCard,
            'virtualization.BaseVirtualSwitch': VirtualizationBaseVirtualSwitch,
            'virtualization.BaseVswitch': VirtualizationBaseVswitch,
            'virtualization.VmwareDatacenter': VirtualizationVmwareDatacenter,
            'virtualization.VmwareDatastore': VirtualizationVmwareDatastore,
            'virtualization.VmwareDatastoreCluster': VirtualizationVmwareDatastoreCluster,
            'virtualization.VmwareDistributedNetwork': VirtualizationVmwareDistributedNetwork,
            'virtualization.VmwareDistributedSwitch': VirtualizationVmwareDistributedSwitch,
            'virtualization.VmwareFolder': VirtualizationVmwareFolder,
            'virtualization.VmwareHost': VirtualizationVmwareHost,
            'virtualization.VmwareKernelNetwork': VirtualizationVmwareKernelNetwork,
            'virtualization.VmwareNetwork': VirtualizationVmwareNetwork,
            'virtualization.VmwarePhysicalNetworkInterface': VirtualizationVmwarePhysicalNetworkInterface,
            'virtualization.VmwareUplinkPort': VirtualizationVmwareUplinkPort,
            'virtualization.VmwareVirtualDisk': VirtualizationVmwareVirtualDisk,
            'virtualization.VmwareVirtualMachine': VirtualizationVmwareVirtualMachine,
            'virtualization.VmwareVirtualMachineSnapshot': VirtualizationVmwareVirtualMachineSnapshot,
            'virtualization.VmwareVirtualNetworkInterface': VirtualizationVmwareVirtualNetworkInterface,
            'virtualization.VmwareVirtualSwitch': VirtualizationVmwareVirtualSwitch,
        }
        if not val:
            return None
        return {'class_id': val}

    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'registered_device': 'RegisteredDevice',  # noqa: E501
        'account_moid': 'AccountMoid',  # noqa: E501
        'create_time': 'CreateTime',  # noqa: E501
        'domain_group_moid': 'DomainGroupMoid',  # noqa: E501
        'mod_time': 'ModTime',  # noqa: E501
        'moid': 'Moid',  # noqa: E501
        'owners': 'Owners',  # noqa: E501
        'shared_scope': 'SharedScope',  # noqa: E501
        'tags': 'Tags',  # noqa: E501
        'version_context': 'VersionContext',  # noqa: E501
        'ancestors': 'Ancestors',  # noqa: E501
        'parent': 'Parent',  # noqa: E501
        'permission_resources': 'PermissionResources',  # noqa: E501
        'display_names': 'DisplayNames',  # noqa: E501
    }

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, class_id, object_type, *args, **kwargs):  # noqa: E501
        """VirtualizationBaseSourceDevice - a model defined in OpenAPI

        Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data. The enum values provides the list of concrete types that can be instantiated from this abstract type.
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property. The enum values provides the list of concrete types that can be instantiated from this abstract type.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
            account_moid (str): The Account ID for this managed object.. [optional]  # noqa: E501
            create_time (datetime): The time when this managed object was created.. [optional]  # noqa: E501
            domain_group_moid (str): The DomainGroup ID for this managed object.. [optional]  # noqa: E501
            mod_time (datetime): The time when this managed object was last modified.. [optional]  # noqa: E501
            moid (str): The unique identifier of this Managed Object instance.. [optional]  # noqa: E501
            owners ([str], none_type): [optional]  # noqa: E501
            shared_scope (str): Intersight provides pre-built workflows, tasks and policies to end users through global catalogs. Objects that are made available through global catalogs are said to have a 'shared' ownership. Shared objects are either made globally available to all end users or restricted to end users based on their license entitlement. Users can use this property to differentiate the scope (global or a specific license tier) to which a shared MO belongs.. [optional]  # noqa: E501
            tags ([MoTag], none_type): [optional]  # noqa: E501
            version_context (MoVersionContext): [optional]  # noqa: E501
            ancestors ([MoBaseMoRelationship], none_type): An array of relationships to moBaseMo resources.. [optional]  # noqa: E501
            parent (MoBaseMoRelationship): [optional]  # noqa: E501
            permission_resources ([MoBaseMoRelationship], none_type): An array of relationships to moBaseMo resources.. [optional]  # noqa: E501
            display_names (DisplayNames): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        required_args = {
            'class_id': class_id,
            'object_type': object_type,
        }
        model_args = {}
        model_args.update(required_args)
        model_args.update(kwargs)
        composed_info = validate_get_composed_info(
            constant_args, model_args, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        unused_args = composed_info[3]

        for var_name, var_value in required_args.items():
            setattr(self, var_name, var_value)
        for var_name, var_value in kwargs.items():
            if var_name in unused_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        not self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error beause the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [
              MoBaseMo,
              VirtualizationBaseSourceDeviceAllOf,
          ],
          'oneOf': [
          ],
        }
