"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.9-4506
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from intersight.model.virtualization_vmware_distributed_switch_relationship import VirtualizationVmwareDistributedSwitchRelationship
    from intersight.model.virtualization_vmware_host_relationship import VirtualizationVmwareHostRelationship
    from intersight.model.virtualization_vmware_teaming_and_failover import VirtualizationVmwareTeamingAndFailover
    from intersight.model.virtualization_vmware_vlan_range import VirtualizationVmwareVlanRange
    globals()['VirtualizationVmwareDistributedSwitchRelationship'] = VirtualizationVmwareDistributedSwitchRelationship
    globals()['VirtualizationVmwareHostRelationship'] = VirtualizationVmwareHostRelationship
    globals()['VirtualizationVmwareTeamingAndFailover'] = VirtualizationVmwareTeamingAndFailover
    globals()['VirtualizationVmwareVlanRange'] = VirtualizationVmwareVlanRange


class VirtualizationVmwareDistributedNetworkAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'VIRTUALIZATION.VMWAREDISTRIBUTEDNETWORK': "virtualization.VmwareDistributedNetwork",
        },
        ('object_type',): {
            'VIRTUALIZATION.VMWAREDISTRIBUTEDNETWORK': "virtualization.VmwareDistributedNetwork",
        },
        ('forged_transmits',): {
            'REJECT': "Reject",
            'ACCEPT': "Accept",
        },
        ('mac_address_changes',): {
            'REJECT': "Reject",
            'ACCEPT': "Accept",
        },
        ('promiscuous_mode',): {
            'REJECT': "Reject",
            'ACCEPT': "Accept",
        },
        ('vlan_type',): {
            'NONE': "None",
            'VLAN': "VLAN",
            'VLAN_TRUNKING': "VLAN trunking",
            'PRIVATE_VLAN': "Private VLAN",
        },
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'forged_transmits': (str,),  # noqa: E501
            'mac_address_changes': (str,),  # noqa: E501
            'nic_teaming_and_failover': (VirtualizationVmwareTeamingAndFailover,),  # noqa: E501
            'num_hosts': (int,),  # noqa: E501
            'num_ports': (int,),  # noqa: E501
            'promiscuous_mode': (str,),  # noqa: E501
            'up_link': (bool,),  # noqa: E501
            'vlan_range': ([VirtualizationVmwareVlanRange], none_type,),  # noqa: E501
            'vlan_type': (str,),  # noqa: E501
            'distributed_switch': (VirtualizationVmwareDistributedSwitchRelationship,),  # noqa: E501
            'hosts': ([VirtualizationVmwareHostRelationship], none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'forged_transmits': 'ForgedTransmits',  # noqa: E501
        'mac_address_changes': 'MacAddressChanges',  # noqa: E501
        'nic_teaming_and_failover': 'NicTeamingAndFailover',  # noqa: E501
        'num_hosts': 'NumHosts',  # noqa: E501
        'num_ports': 'NumPorts',  # noqa: E501
        'promiscuous_mode': 'PromiscuousMode',  # noqa: E501
        'up_link': 'UpLink',  # noqa: E501
        'vlan_range': 'VlanRange',  # noqa: E501
        'vlan_type': 'VlanType',  # noqa: E501
        'distributed_switch': 'DistributedSwitch',  # noqa: E501
        'hosts': 'Hosts',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """VirtualizationVmwareDistributedNetworkAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "virtualization.VmwareDistributedNetwork", must be one of ["virtualization.VmwareDistributedNetwork", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "virtualization.VmwareDistributedNetwork", must be one of ["virtualization.VmwareDistributedNetwork", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            forged_transmits (str): If forgedTransmits property value is set to reject, outbound frames with a source MAC address different from the one set on the adapter are dropped. If property value is set to accept, no filtering is performed and all outbound frames are passed. * `Reject` - Indicates that the security policy is rejected. * `Accept` - Indicates that the security policy is accepted.. [optional] if omitted the server will use the default value of "Reject"  # noqa: E501
            mac_address_changes (str): If macAddressChanges property value is set to reject and the MAC address of the adapter is changed to a value other than the one specified in .vmx configuration file, all inbound frames are dropped. If property value is set to accept and the MAC address is changed, inbound frames to the new MAC address are received. * `Reject` - Indicates that the security policy is rejected. * `Accept` - Indicates that the security policy is accepted.. [optional] if omitted the server will use the default value of "Reject"  # noqa: E501
            nic_teaming_and_failover (VirtualizationVmwareTeamingAndFailover): [optional]  # noqa: E501
            num_hosts (int): The total number of hosts connected to this distributed virtual network.. [optional]  # noqa: E501
            num_ports (int): The total number of ports in the distributed virtual network.. [optional]  # noqa: E501
            promiscuous_mode (str): If promiscuousMode property value is set to reject, incoming traffic only targeted to that network will be visible. If property value is set to accept, objects defined within the network can see all incoming traffic on the virtual switch based on the VLAN policy. * `Reject` - Indicates that the security policy is rejected. * `Accept` - Indicates that the security policy is accepted.. [optional] if omitted the server will use the default value of "Reject"  # noqa: E501
            up_link (bool): Indicates if the distributed virtual network is a uplink.. [optional]  # noqa: E501
            vlan_range ([VirtualizationVmwareVlanRange], none_type): [optional]  # noqa: E501
            vlan_type (str): VLAN type of the distributed virtual network. It can be None, VLAN, VLAN Trunking or Private VLAN. * `None` - Do not tag traffic with any VLAN Id. * `VLAN` - Tag traffic with the Id from the VLAN Id field. * `VLAN trunking` - Pass VLAN traffic with Id within the VLAN trunk range to guest operating system. * `Private VLAN` - Associate the traffic with a private VLAN created on the distributed switch.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
            distributed_switch (VirtualizationVmwareDistributedSwitchRelationship): [optional]  # noqa: E501
            hosts ([VirtualizationVmwareHostRelationship], none_type): An array of relationships to virtualizationVmwareHost resources.. [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "virtualization.VmwareDistributedNetwork")
        object_type = kwargs.get('object_type', "virtualization.VmwareDistributedNetwork")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
